import { createAutomation as publicCreateAutomation, getAutomation as publicGetAutomation, updateAutomation as publicUpdateAutomation, deleteAutomation as publicDeleteAutomation, bulkDeleteAutomations as publicBulkDeleteAutomations, createPreinstalledAutomation as publicCreatePreinstalledAutomation, updatePreinstalledAutomation as publicUpdatePreinstalledAutomation, deletePreinstalledAutomation as publicDeletePreinstalledAutomation, queryPreinstalledAutomationsForApp as publicQueryPreinstalledAutomationsForApp, queryAutomations as publicQueryAutomations, copyAutomation as publicCopyAutomation, createDraftAutomation as publicCreateDraftAutomation, getOrCreateDraftAutomation as publicGetOrCreateDraftAutomation, updateDraftAutomation as publicUpdateDraftAutomation, queryAutomationsWithDrafts as publicQueryAutomationsWithDrafts, deleteDraftAutomation as publicDeleteDraftAutomation, publishDraftAutomation as publicPublishDraftAutomation, validateAutomation as publicValidateAutomation, validateAutomationById as publicValidateAutomationById, getAutomationActionSchema as publicGetAutomationActionSchema, getActionsQuotaInfo as publicGetActionsQuotaInfo } from './automations-v2-automation-automations-service-v-2.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onAutomationCreated as publicOnAutomationCreated } from './automations-v2-automation-automations-service-v-2.public.js';
import { onAutomationDeleted as publicOnAutomationDeleted } from './automations-v2-automation-automations-service-v-2.public.js';
import { onAutomationDeletedWithEntity as publicOnAutomationDeletedWithEntity } from './automations-v2-automation-automations-service-v-2.public.js';
import { onAutomationUpdated as publicOnAutomationUpdated } from './automations-v2-automation-automations-service-v-2.public.js';
import { onAutomationUpdatedWithPreviousEntity as publicOnAutomationUpdatedWithPreviousEntity } from './automations-v2-automation-automations-service-v-2.public.js';
export declare const createAutomation: MaybeContext<BuildRESTFunction<typeof publicCreateAutomation> & typeof publicCreateAutomation>;
export declare const getAutomation: MaybeContext<BuildRESTFunction<typeof publicGetAutomation> & typeof publicGetAutomation>;
export declare const updateAutomation: MaybeContext<BuildRESTFunction<typeof publicUpdateAutomation> & typeof publicUpdateAutomation>;
export declare const deleteAutomation: MaybeContext<BuildRESTFunction<typeof publicDeleteAutomation> & typeof publicDeleteAutomation>;
export declare const bulkDeleteAutomations: MaybeContext<BuildRESTFunction<typeof publicBulkDeleteAutomations> & typeof publicBulkDeleteAutomations>;
export declare const createPreinstalledAutomation: MaybeContext<BuildRESTFunction<typeof publicCreatePreinstalledAutomation> & typeof publicCreatePreinstalledAutomation>;
export declare const updatePreinstalledAutomation: MaybeContext<BuildRESTFunction<typeof publicUpdatePreinstalledAutomation> & typeof publicUpdatePreinstalledAutomation>;
export declare const deletePreinstalledAutomation: MaybeContext<BuildRESTFunction<typeof publicDeletePreinstalledAutomation> & typeof publicDeletePreinstalledAutomation>;
export declare const queryPreinstalledAutomationsForApp: MaybeContext<BuildRESTFunction<typeof publicQueryPreinstalledAutomationsForApp> & typeof publicQueryPreinstalledAutomationsForApp>;
export declare const queryAutomations: MaybeContext<BuildRESTFunction<typeof publicQueryAutomations> & typeof publicQueryAutomations>;
export declare const copyAutomation: MaybeContext<BuildRESTFunction<typeof publicCopyAutomation> & typeof publicCopyAutomation>;
export declare const createDraftAutomation: MaybeContext<BuildRESTFunction<typeof publicCreateDraftAutomation> & typeof publicCreateDraftAutomation>;
export declare const getOrCreateDraftAutomation: MaybeContext<BuildRESTFunction<typeof publicGetOrCreateDraftAutomation> & typeof publicGetOrCreateDraftAutomation>;
export declare const updateDraftAutomation: MaybeContext<BuildRESTFunction<typeof publicUpdateDraftAutomation> & typeof publicUpdateDraftAutomation>;
export declare const queryAutomationsWithDrafts: MaybeContext<BuildRESTFunction<typeof publicQueryAutomationsWithDrafts> & typeof publicQueryAutomationsWithDrafts>;
export declare const deleteDraftAutomation: MaybeContext<BuildRESTFunction<typeof publicDeleteDraftAutomation> & typeof publicDeleteDraftAutomation>;
export declare const publishDraftAutomation: MaybeContext<BuildRESTFunction<typeof publicPublishDraftAutomation> & typeof publicPublishDraftAutomation>;
export declare const validateAutomation: MaybeContext<BuildRESTFunction<typeof publicValidateAutomation> & typeof publicValidateAutomation>;
export declare const validateAutomationById: MaybeContext<BuildRESTFunction<typeof publicValidateAutomationById> & typeof publicValidateAutomationById>;
export declare const getAutomationActionSchema: MaybeContext<BuildRESTFunction<typeof publicGetAutomationActionSchema> & typeof publicGetAutomationActionSchema>;
export declare const getActionsQuotaInfo: MaybeContext<BuildRESTFunction<typeof publicGetActionsQuotaInfo> & typeof publicGetActionsQuotaInfo>;
/** */
export declare const onAutomationCreated: ReturnType<typeof createEventModule<typeof publicOnAutomationCreated>>;
/** */
export declare const onAutomationDeleted: ReturnType<typeof createEventModule<typeof publicOnAutomationDeleted>>;
/** */
export declare const onAutomationDeletedWithEntity: ReturnType<typeof createEventModule<typeof publicOnAutomationDeletedWithEntity>>;
/** */
export declare const onAutomationUpdated: ReturnType<typeof createEventModule<typeof publicOnAutomationUpdated>>;
/** */
export declare const onAutomationUpdatedWithPreviousEntity: ReturnType<typeof createEventModule<typeof publicOnAutomationUpdatedWithPreviousEntity>>;
export { Domain, TimeUnit, Operator, Type, Status, Origin, WebhookIdentityType, RequestedFields, SortOrder, State, SiteCreatedContext, Namespace, DeleteStatus, TriggerValidationErrorValidationErrorType, TriggerErrorType, ValidationErrorSeverity, ValidationErrorType, ActionErrorType, AutomationValidationErrorValidationErrorType, AutomationErrorType, } from './automations-v2-automation-automations-service-v-2.universal.js';
export { Automation, AutomationOriginInfoOneOf, ActionSettings, Enrichment, AuditInfo, AuditInfoIdOneOf, AutomationConfiguration, Filter, FutureDateActivationOffset, RateLimit, FilterValueSelection, ConditionExpressionGroup, AppDefinedAction, ConditionAction, DelayAction, RateLimitAction, SetVariablesAction, OutputAction, Trigger, Action, ActionInfoOneOf, FilterableAppDefinedActions, ApplicationOrigin, PreinstalledOrigin, AutomationSettings, DraftInfo, Enrichments, ExtendedFields, UpdatedWithPreviousEntity, DeletedWithEntity, DraftPublished, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, Empty, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, CreateAutomationRequest, CreateAutomationResponse, GetAutomationRequest, GetAutomationResponse, UpdateAutomationRequest, UpdateAutomationResponse, DeleteAutomationRequest, DeleteAutomationResponse, BulkDeleteAutomationsRequest, BulkDeleteAutomationsResponse, BulkDeleteResult, ItemMetadata, ApplicationError, BulkActionMetadata, CreatePreinstalledAutomationRequest, PreinstalledAutomationSpecInfo, OriginAutomationInfo, CreatePreinstalledAutomationResponse, UpdatePreinstalledAutomationRequest, UpdatePreinstalledAutomationResponse, DeletePreinstalledAutomationRequest, DeletePreinstalledAutomationResponse, GeneratePreinstalledAutomationRequest, GeneratePreinstalledAutomationResponse, QueryPreinstalledAutomationsForAppRequest, CursorQuery, CursorQueryPagingMethodOneOf, Sorting, CursorPaging, QueryPreinstalledAutomationsForAppResponse, CursorPagingMetadata, Cursors, QueryAutomationsRequest, QueryAutomationsResponse, GetAggregatedUsageInfoRequest, GetAggregatedUsageInfoResponse, TriggerUsageSummary, ActionUsageSummary, CopyAutomationRequest, CopyAutomationResponse, MetaSiteSpecialEvent, MetaSiteSpecialEventPayloadOneOf, Asset, SiteCreated, SiteTransferred, SiteDeleted, DeleteContext, SiteUndeleted, SitePublished, SiteUnpublished, SiteMarkedAsTemplate, SiteMarkedAsWixSite, ServiceProvisioned, ServiceRemoved, SiteRenamed, SiteHardDeleted, NamespaceChanged, StudioAssigned, StudioUnassigned, SiteUrlChanged, CreateDraftAutomationRequest, CreateDraftAutomationResponse, GetOrCreateDraftAutomationRequest, GetOrCreateDraftAutomationResponse, UpdateDraftAutomationRequest, UpdateDraftAutomationResponse, QueryAutomationsWithDraftsRequest, QueryAutomationsWithDraftsResponse, DraftsInfo, DeleteDraftAutomationRequest, DeleteDraftAutomationResponse, PublishDraftAutomationRequest, PublishDraftAutomationResponse, ValidateAutomationRequest, ValidationSettings, ValidateAutomationResponse, TriggerValidationError, TriggerValidationErrorErrorOneOf, TriggerConfigurationError, ProviderConfigurationError, ActionValidationInfo, ActionValidationError, ActionValidationErrorErrorOneOf, ActionConfigurationError, AutomationValidationError, AutomationValidationErrorErrorOneOf, AutomationConfigurationError, ValidateAutomationByIdRequest, ValidateAutomationByIdResponse, GetAutomationActionSchemaRequest, GetAutomationActionSchemaResponse, GetActionsQuotaInfoRequest, GetActionsQuotaInfoResponse, ActionProviderQuotaInfo, ActionQuotaInfo, QuotaInfo, Plan, Quota, CTA, AdditionalInfo, UpgradeCTA, MigrateVeloActionAutomationsRequest, MigrateVeloActionAutomationsResponse, GetAutomationRevisionRequest, GetAutomationRevisionResponse, AutomationNonNullableFields, CreateAutomationResponseNonNullableFields, GetAutomationResponseNonNullableFields, UpdateAutomationResponseNonNullableFields, BulkDeleteAutomationsResponseNonNullableFields, CreatePreinstalledAutomationResponseNonNullableFields, UpdatePreinstalledAutomationResponseNonNullableFields, QueryPreinstalledAutomationsForAppResponseNonNullableFields, QueryAutomationsResponseNonNullableFields, CopyAutomationResponseNonNullableFields, CreateDraftAutomationResponseNonNullableFields, GetOrCreateDraftAutomationResponseNonNullableFields, UpdateDraftAutomationResponseNonNullableFields, QueryAutomationsWithDraftsResponseNonNullableFields, PublishDraftAutomationResponseNonNullableFields, ValidateAutomationResponseNonNullableFields, ValidateAutomationByIdResponseNonNullableFields, GetActionsQuotaInfoResponseNonNullableFields, GetAutomationRevisionResponseNonNullableFields, BaseEventMetadata, EventMetadata, AutomationCreatedEnvelope, AutomationDeletedEnvelope, AutomationDeletedWithEntityEnvelope, AutomationUpdatedEnvelope, AutomationUpdatedWithPreviousEntityEnvelope, CreateAutomationOptions, GetAutomationOptions, UpdateAutomation, UpdateAutomationOptions, CreatePreinstalledAutomationOptions, UpdatePreinstalledAutomationOptions, DeletePreinstalledAutomationOptions, QueryPreinstalledAutomationsForAppOptions, QueryAutomationsOptions, AutomationsQueryResult, AutomationsQueryBuilder, CopyAutomationOptions, CreateDraftAutomationOptions, GetOrCreateDraftAutomationOptions, UpdateDraftAutomation, UpdateDraftAutomationOptions, QueryAutomationsWithDraftsOptions, PublishDraftAutomationOptions, ValidateAutomationOptions, ValidateAutomationByIdOptions, GetAutomationActionSchemaIdentifiers, GetAutomationRevisionOptions, } from './automations-v2-automation-automations-service-v-2.universal.js';
