import { transformError as sdkTransformError } from '@wix/sdk-runtime/transform-error';
import { queryBuilder } from '@wix/sdk-runtime/query-builder';
import { renameKeysFromSDKRequestToRESTRequest, renameKeysFromRESTResponseToSDKResponse, } from '@wix/sdk-runtime/rename-all-nested-keys';
import * as ambassadorWixAutomationsV2Automation from './automations-v2-automation-automations-service-v-2.http.js';
export var Domain;
(function (Domain) {
    /** User domain (default). */
    Domain["USER"] = "USER";
    /** Wix domain. */
    Domain["WIX"] = "WIX";
})(Domain || (Domain = {}));
export var TimeUnit;
(function (TimeUnit) {
    TimeUnit["UNKNOWN_TIME_UNIT"] = "UNKNOWN_TIME_UNIT";
    TimeUnit["MINUTES"] = "MINUTES";
    TimeUnit["HOURS"] = "HOURS";
    TimeUnit["DAYS"] = "DAYS";
    TimeUnit["WEEKS"] = "WEEKS";
    TimeUnit["MONTHS"] = "MONTHS";
})(TimeUnit || (TimeUnit = {}));
export var Operator;
(function (Operator) {
    Operator["UNKNOWN_OPERATOR"] = "UNKNOWN_OPERATOR";
    Operator["OR"] = "OR";
    Operator["AND"] = "AND";
})(Operator || (Operator = {}));
export var Type;
(function (Type) {
    /** Automation will be triggered according to the trigger configuration. */
    Type["UNKNOWN_ACTION_TYPE"] = "UNKNOWN_ACTION_TYPE";
    /** App defined Action. */
    Type["APP_DEFINED"] = "APP_DEFINED";
    /** Condition Action. */
    Type["CONDITION"] = "CONDITION";
    /** Delay Action. */
    Type["DELAY"] = "DELAY";
    /** RateLimit Action. */
    Type["RATE_LIMIT"] = "RATE_LIMIT";
    /** Set Variables Action. */
    Type["SET_VARIABLES"] = "SET_VARIABLES";
    /** Output Action. */
    Type["OUTPUT"] = "OUTPUT";
})(Type || (Type = {}));
export var Status;
(function (Status) {
    /** unused */
    Status["UNKNOWN_STATUS"] = "UNKNOWN_STATUS";
    /** Automation will be triggered according to the trigger configuration */
    Status["ACTIVE"] = "ACTIVE";
    /** Automation will not be triggered */
    Status["INACTIVE"] = "INACTIVE";
})(Status || (Status = {}));
export var Origin;
(function (Origin) {
    /** Default value. This is unused. */
    Origin["UNKNOWN_ORIGIN"] = "UNKNOWN_ORIGIN";
    /** User created automation. */
    Origin["USER"] = "USER";
    /** Automation created by application (site specific). */
    Origin["APPLICATION"] = "APPLICATION";
    /** Preinstalled application automation. */
    Origin["PREINSTALLED"] = "PREINSTALLED";
    /** Automation created from a recipe. */
    Origin["RECIPE"] = "RECIPE";
})(Origin || (Origin = {}));
export var WebhookIdentityType;
(function (WebhookIdentityType) {
    WebhookIdentityType["UNKNOWN"] = "UNKNOWN";
    WebhookIdentityType["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
    WebhookIdentityType["MEMBER"] = "MEMBER";
    WebhookIdentityType["WIX_USER"] = "WIX_USER";
    WebhookIdentityType["APP"] = "APP";
})(WebhookIdentityType || (WebhookIdentityType = {}));
export var RequestedFields;
(function (RequestedFields) {
    RequestedFields["UNKNOWN_REQUESTED_FIELD"] = "UNKNOWN_REQUESTED_FIELD";
    RequestedFields["OVERRIDE_SCHEMA"] = "OVERRIDE_SCHEMA";
    RequestedFields["FILTERABLE_EXTERNAL_VALUES"] = "FILTERABLE_EXTERNAL_VALUES";
    RequestedFields["FILTERABLE_APP_DEFINED_ACTIONS"] = "FILTERABLE_APP_DEFINED_ACTIONS";
})(RequestedFields || (RequestedFields = {}));
export var SortOrder;
(function (SortOrder) {
    SortOrder["ASC"] = "ASC";
    SortOrder["DESC"] = "DESC";
})(SortOrder || (SortOrder = {}));
export var State;
(function (State) {
    State["UNKNOWN"] = "UNKNOWN";
    State["ENABLED"] = "ENABLED";
    State["DISABLED"] = "DISABLED";
    State["PENDING"] = "PENDING";
    State["DEMO"] = "DEMO";
})(State || (State = {}));
export var SiteCreatedContext;
(function (SiteCreatedContext) {
    /** A valid option, we don't expose all reasons why site might be created. */
    SiteCreatedContext["OTHER"] = "OTHER";
    /** A meta site was created from template. */
    SiteCreatedContext["FROM_TEMPLATE"] = "FROM_TEMPLATE";
    /** A meta site was created by copying of the transfferred meta site. */
    SiteCreatedContext["DUPLICATE_BY_SITE_TRANSFER"] = "DUPLICATE_BY_SITE_TRANSFER";
    /** A copy of existing meta site. */
    SiteCreatedContext["DUPLICATE"] = "DUPLICATE";
    /** A meta site was created as a transfferred site (copy of the original), old flow, should die soon. */
    SiteCreatedContext["OLD_SITE_TRANSFER"] = "OLD_SITE_TRANSFER";
    /** deprecated A meta site was created for Flash editor. */
    SiteCreatedContext["FLASH"] = "FLASH";
})(SiteCreatedContext || (SiteCreatedContext = {}));
export var Namespace;
(function (Namespace) {
    Namespace["UNKNOWN_NAMESPACE"] = "UNKNOWN_NAMESPACE";
    /** Default namespace for UGC sites. MetaSites with this namespace will be shown in a user's site list by default. */
    Namespace["WIX"] = "WIX";
    /** ShoutOut stand alone product. These are siteless (no actual Wix site, no HtmlWeb). MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["SHOUT_OUT"] = "SHOUT_OUT";
    /** MetaSites created by the Albums product, they appear as part of the Albums app. MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["ALBUMS"] = "ALBUMS";
    /** Part of the WixStores migration flow, a user tries to migrate and gets this site to view and if the user likes it then stores removes this namespace and deletes the old site with the old stores. MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["WIX_STORES_TEST_DRIVE"] = "WIX_STORES_TEST_DRIVE";
    /** Hotels standalone (siteless). MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["HOTELS"] = "HOTELS";
    /** Clubs siteless MetaSites, a club without a wix website. MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["CLUBS"] = "CLUBS";
    /** A partially created ADI website. MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["ONBOARDING_DRAFT"] = "ONBOARDING_DRAFT";
    /** AppBuilder for AppStudio / shmite (c). MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["DEV_SITE"] = "DEV_SITE";
    /** LogoMaker websites offered to the user after logo purchase. MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["LOGOS"] = "LOGOS";
    /** VideoMaker websites offered to the user after video purchase. MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["VIDEO_MAKER"] = "VIDEO_MAKER";
    /** MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["PARTNER_DASHBOARD"] = "PARTNER_DASHBOARD";
    /** MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["DEV_CENTER_COMPANY"] = "DEV_CENTER_COMPANY";
    /**
     * A draft created by HTML editor on open. Upon "first save" it will be moved to be of WIX domain.
     *
     * Meta site with this namespace will *not* be shown in a user's site list by default.
     */
    Namespace["HTML_DRAFT"] = "HTML_DRAFT";
    /**
     * the user-journey for Fitness users who want to start from managing their business instead of designing their website.
     * Will be accessible from Site List and will not have a website app.
     * Once the user attaches a site, the site will become a regular wixsite.
     */
    Namespace["SITELESS_BUSINESS"] = "SITELESS_BUSINESS";
    /** Belongs to "strategic products" company. Supports new product in the creator's economy space. */
    Namespace["CREATOR_ECONOMY"] = "CREATOR_ECONOMY";
    /** It is to be used in the Business First efforts. */
    Namespace["DASHBOARD_FIRST"] = "DASHBOARD_FIRST";
    /** Bookings business flow with no site. */
    Namespace["ANYWHERE"] = "ANYWHERE";
    /** Namespace for Headless Backoffice with no editor */
    Namespace["HEADLESS"] = "HEADLESS";
    /**
     * Namespace for master site that will exist in parent account that will be referenced by subaccounts
     * The site will be used for account level CSM feature for enterprise
     */
    Namespace["ACCOUNT_MASTER_CMS"] = "ACCOUNT_MASTER_CMS";
    /** Rise.ai Siteless account management for Gift Cards and Store Credit. */
    Namespace["RISE"] = "RISE";
    /**
     * As part of the branded app new funnel, users now can create a meta site that will be branded app first.
     * There's a blank site behind the scene but it's blank).
     * The Mobile company will be the owner of this namespace.
     */
    Namespace["BRANDED_FIRST"] = "BRANDED_FIRST";
    /** Nownia.com Siteless account management for Ai Scheduling Assistant. */
    Namespace["NOWNIA"] = "NOWNIA";
    /**
     * UGC Templates are templates that are created by users for personal use and to sale to other users.
     * The Partners company owns this namespace.
     */
    Namespace["UGC_TEMPLATE"] = "UGC_TEMPLATE";
    /** Codux Headless Sites */
    Namespace["CODUX"] = "CODUX";
    /** Bobb - AI Design Creator. */
    Namespace["MEDIA_DESIGN_CREATOR"] = "MEDIA_DESIGN_CREATOR";
    /**
     * Shared Blog Site is a unique single site across Enterprise account,
     * This site will hold all Blog posts related to the Marketing product.
     */
    Namespace["SHARED_BLOG_ENTERPRISE"] = "SHARED_BLOG_ENTERPRISE";
    /** Standalone forms (siteless). MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["STANDALONE_FORMS"] = "STANDALONE_FORMS";
    /** Standalone events (siteless). MetaSites with this namespace will *not* be shown in a user's site list by default. */
    Namespace["STANDALONE_EVENTS"] = "STANDALONE_EVENTS";
})(Namespace || (Namespace = {}));
export var DeleteStatus;
(function (DeleteStatus) {
    DeleteStatus["UNKNOWN"] = "UNKNOWN";
    DeleteStatus["TRASH"] = "TRASH";
    DeleteStatus["DELETED"] = "DELETED";
    DeleteStatus["PENDING_PURGE"] = "PENDING_PURGE";
    DeleteStatus["PURGED_EXTERNALLY"] = "PURGED_EXTERNALLY";
})(DeleteStatus || (DeleteStatus = {}));
export var TriggerValidationErrorValidationErrorType;
(function (TriggerValidationErrorValidationErrorType) {
    TriggerValidationErrorValidationErrorType["UNKNOWN_VALIDATION_ERROR_TYPE"] = "UNKNOWN_VALIDATION_ERROR_TYPE";
    TriggerValidationErrorValidationErrorType["CONFIGURATION_ERROR"] = "CONFIGURATION_ERROR";
    TriggerValidationErrorValidationErrorType["PROVIDER_ERROR"] = "PROVIDER_ERROR";
})(TriggerValidationErrorValidationErrorType || (TriggerValidationErrorValidationErrorType = {}));
export var TriggerErrorType;
(function (TriggerErrorType) {
    TriggerErrorType["UNKNOWN_TRIGGER_ERROR_TYPE"] = "UNKNOWN_TRIGGER_ERROR_TYPE";
    TriggerErrorType["NOT_FOUND"] = "NOT_FOUND";
    TriggerErrorType["APP_NOT_INSTALLED"] = "APP_NOT_INSTALLED";
    TriggerErrorType["MODERATION_MISMATCH"] = "MODERATION_MISMATCH";
    TriggerErrorType["DEPRECATED"] = "DEPRECATED";
    TriggerErrorType["INVALID_TRIGGER_KEY"] = "INVALID_TRIGGER_KEY";
    TriggerErrorType["INVALID_FILTER_FIELD_KEY"] = "INVALID_FILTER_FIELD_KEY";
    TriggerErrorType["INVALID_FILTER_EXPRESSION"] = "INVALID_FILTER_EXPRESSION";
})(TriggerErrorType || (TriggerErrorType = {}));
export var ValidationErrorSeverity;
(function (ValidationErrorSeverity) {
    ValidationErrorSeverity["UNKNOWN_VALIDATION_ERROR_SEVERITY"] = "UNKNOWN_VALIDATION_ERROR_SEVERITY";
    ValidationErrorSeverity["WARNING"] = "WARNING";
    ValidationErrorSeverity["ERROR"] = "ERROR";
})(ValidationErrorSeverity || (ValidationErrorSeverity = {}));
export var ValidationErrorType;
(function (ValidationErrorType) {
    ValidationErrorType["UNKNOWN_VALIDATION_ERROR_TYPE"] = "UNKNOWN_VALIDATION_ERROR_TYPE";
    ValidationErrorType["CONFIGURATION_ERROR"] = "CONFIGURATION_ERROR";
    ValidationErrorType["PROVIDER_ERROR"] = "PROVIDER_ERROR";
})(ValidationErrorType || (ValidationErrorType = {}));
export var ActionErrorType;
(function (ActionErrorType) {
    ActionErrorType["UNKNOWN_ACTION_ERROR_TYPE"] = "UNKNOWN_ACTION_ERROR_TYPE";
    ActionErrorType["NOT_FOUND"] = "NOT_FOUND";
    ActionErrorType["APP_NOT_INSTALLED"] = "APP_NOT_INSTALLED";
    ActionErrorType["MODERATION_MISMATCH"] = "MODERATION_MISMATCH";
    ActionErrorType["DEPRECATED"] = "DEPRECATED";
    ActionErrorType["INVALID_ACTION_KEY"] = "INVALID_ACTION_KEY";
    ActionErrorType["INVALID_MAPPING"] = "INVALID_MAPPING";
    ActionErrorType["MAPPING_TYPE_MISMATCH"] = "MAPPING_TYPE_MISMATCH";
    ActionErrorType["MAPPING_MISSING_REQUIRED_FIELD"] = "MAPPING_MISSING_REQUIRED_FIELD";
    ActionErrorType["MAPPING_SCHEMA_MISMATCH"] = "MAPPING_SCHEMA_MISMATCH";
    ActionErrorType["MAPPING_VARIABLE_MISSING_FROM_SCHEMA"] = "MAPPING_VARIABLE_MISSING_FROM_SCHEMA";
})(ActionErrorType || (ActionErrorType = {}));
export var AutomationValidationErrorValidationErrorType;
(function (AutomationValidationErrorValidationErrorType) {
    AutomationValidationErrorValidationErrorType["UNKNOWN_VALIDATION_ERROR_TYPE"] = "UNKNOWN_VALIDATION_ERROR_TYPE";
    AutomationValidationErrorValidationErrorType["CONFIGURATION_ERROR"] = "CONFIGURATION_ERROR";
    AutomationValidationErrorValidationErrorType["PROVIDER_ERROR"] = "PROVIDER_ERROR";
})(AutomationValidationErrorValidationErrorType || (AutomationValidationErrorValidationErrorType = {}));
export var AutomationErrorType;
(function (AutomationErrorType) {
    AutomationErrorType["UNKNOWN_AUTOMATION_ERROR_TYPE"] = "UNKNOWN_AUTOMATION_ERROR_TYPE";
})(AutomationErrorType || (AutomationErrorType = {}));
/**
 * Creates an automation.
 * @param automation - Automation to be created.
 * @public
 * @documentationMaturity preview
 * @requiredField automation
 * @requiredField automation.configuration
 * @requiredField automation.configuration.actions
 * @requiredField automation.configuration.rootActionIds
 * @requiredField automation.configuration.status
 * @requiredField automation.configuration.trigger
 * @requiredField automation.configuration.trigger.appId
 * @requiredField automation.configuration.trigger.triggerKey
 * @requiredField automation.name
 * @requiredField automation.origin
 * @permissionId AUTOMATIONS.AUTOMATION_CREATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @returns The created automation.
 * @fqn wix.automations.v2.AutomationsService.CreateAutomation
 */
export async function createAutomation(automation, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: automation,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.createAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data)?.automation;
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { automation: '$[0]', fields: '$[1].fields' },
            singleArgumentUnchanged: false,
        }, ['automation', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Retrieves an automation.
 * @param automationId - Automation ID.
 * @public
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_READ
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @returns The requested automation.
 * @fqn wix.automations.v2.AutomationsService.GetAutomation
 */
export async function getAutomation(automationId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
        origin: options?.origin,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.getAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data)?.automation;
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automationId: '$[0]',
                origin: '$[1].origin',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['automationId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Updates an automation.
 *
 * Each time the automation is updated,
 * `revision` increments by 1.
 * The current `revision` must be passed when updating the automation.
 * This ensures you're working with the latest automation
 * and prevents unintended overwrites.
 * @param _id - Automation ID.
 * @public
 * @documentationMaturity preview
 * @requiredField _id
 * @requiredField automation
 * @requiredField automation.revision
 * @permissionId AUTOMATIONS.AUTOMATION_UPDATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @returns Updated automation.
 * @fqn wix.automations.v2.AutomationsService.UpdateAutomation
 */
export async function updateAutomation(_id, automation, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[3];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: { ...automation, id: _id },
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.updateAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data)?.automation;
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: { automation: '$[1]' },
            explicitPathsToArguments: {
                'automation.id': '$[0]',
                fields: '$[2].fields',
            },
            singleArgumentUnchanged: false,
        }, ['_id', 'automation', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Deletes an Automation.
 * @param automationId - Automation ID.
 * @public
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_DELETE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.DeleteAutomation
 */
export async function deleteAutomation(automationId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.deleteAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { automationId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['automationId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Deletes multiple automations.
 * @param automationIds - Automation IDs to delete.
 * @public
 * @documentationMaturity preview
 * @requiredField automationIds
 * @permissionId AUTOMATIONS.AUTOMATION_DELETE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.BulkDeleteAutomations
 */
export async function bulkDeleteAutomations(automationIds) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationIds: automationIds,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.bulkDeleteAutomations(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { automationIds: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['automationIds']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * We have a special identification mechanism here with Dev Center.
 * @param automation - Preinstalled automation to be created.
 * @public
 * @documentationMaturity preview
 * @requiredField automation
 * @requiredField automation.configuration
 * @requiredField automation.configuration.actions
 * @requiredField automation.configuration.rootActionIds
 * @requiredField automation.configuration.status
 * @requiredField automation.configuration.trigger
 * @requiredField automation.configuration.trigger.appId
 * @requiredField automation.configuration.trigger.triggerKey
 * @requiredField automation.name
 * @fqn wix.automations.v2.AutomationsService.CreatePreinstalledAutomation
 */
export async function createPreinstalledAutomation(automation, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: automation,
        specInfo: options?.specInfo,
        originAutomationInfo: options?.originAutomationInfo,
        appId: options?.appId,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.createPreinstalledAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automation: '$[0]',
                specInfo: '$[1].specInfo',
                originAutomationInfo: '$[1].originAutomationInfo',
                appId: '$[1].appId',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['automation', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * We have a special identification mechanism here with Dev Center.
 * @param automation - Preinstalled automation to update.
 * @public
 * @documentationMaturity preview
 * @requiredField automation
 * @requiredField automation.originInfo.preinstalledInfo
 * @requiredField automation.originInfo.preinstalledInfo.componentId
 * @requiredField automation.originInfo.preinstalledInfo.componentVersion
 * @fqn wix.automations.v2.AutomationsService.UpdatePreinstalledAutomation
 */
export async function updatePreinstalledAutomation(automation, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: automation,
        specInfo: options?.specInfo,
        appId: options?.appId,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.updatePreinstalledAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automation: '$[0]',
                specInfo: '$[1].specInfo',
                appId: '$[1].appId',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['automation', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * We have a special identification mechanism here with Dev Center.
 * @param componentId - Preinstalled Component Id
 * @public
 * @documentationMaturity preview
 * @requiredField componentId
 * @fqn wix.automations.v2.AutomationsService.DeletePreinstalledAutomation
 */
export async function deletePreinstalledAutomation(componentId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        componentId: componentId,
        specInfo: options?.specInfo,
        appId: options?.appId,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.deletePreinstalledAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                componentId: '$[0]',
                specInfo: '$[1].specInfo',
                appId: '$[1].appId',
            },
            singleArgumentUnchanged: false,
        }, ['componentId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * We have a special identification mechanism here with Dev Center.
 * @public
 * @documentationMaturity preview
 * @fqn wix.automations.v2.AutomationsService.QueryPreinstalledAutomationsForApp
 */
export async function queryPreinstalledAutomationsForApp(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        query: options?.query,
        appId: options?.appId,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.queryPreinstalledAutomationsForApp(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                query: '$[0].query',
                appId: '$[0].appId',
                fields: '$[0].fields',
            },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Retrieves a list of automations. Max query filter depth is 3.
 *
 * Relevant automations for the query are returned. This includes automations created on the site and pre-installed automations.
 * If there's an existing override for a pre-installed automation, the override is returned in the query result.
 * The query only returns automations from apps that are installed on the site.
 *
 * To learn about working with _Query_ endpoints, see
 * [API Query Language](https://dev.wix.com/api/rest/getting-started/api-query-language),
 * [Sorting and Paging](https://dev.wix.com/api/rest/getting-started/pagination),
 * and [Field Projection](https://dev.wix.com/api/rest/getting-started/field-projection).
 * @public
 * @documentationMaturity preview
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @permissionId AUTOMATIONS.AUTOMATION_READ
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.QueryAutomations
 */
export function queryAutomations(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    return queryBuilder({
        func: async (payload) => {
            const reqOpts = ambassadorWixAutomationsV2Automation.queryAutomations({
                ...payload,
                ...(options ?? {}),
            });
            sideEffects?.onSiteCall?.();
            try {
                const result = await httpClient.request(reqOpts);
                sideEffects?.onSuccess?.(result);
                return result;
            }
            catch (err) {
                sideEffects?.onError?.(err);
                throw err;
            }
        },
        requestTransformer: (query) => {
            const args = [query, options];
            return renameKeysFromSDKRequestToRESTRequest({
                ...args?.[1],
                query: args?.[0],
            });
        },
        responseTransformer: ({ data }) => {
            const transformedData = renameKeysFromRESTResponseToSDKResponse(data);
            return {
                items: transformedData?.automations,
                pagingMetadata: transformedData?.pagingMetadata,
            };
        },
        errorTransformer: (err) => {
            const transformedError = sdkTransformError(err, {
                spreadPathsToArguments: {},
                explicitPathsToArguments: { query: '$[0]' },
                singleArgumentUnchanged: false,
            });
            throw transformedError;
        },
        pagingMethod: 'CURSOR',
        transformationPaths: {},
    });
}
/**
 * Creates a copy of an action with a new ID, and changes the action's input mapping if necessary.
 *
 * The action copy isn't saved automatically. To save it, the user must perform an action
 * such as clicking the **Save** button.
 * @param automationId - Automation ID.
 * @public
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_COPY
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.CopyAutomation
 */
export async function copyAutomation(automationId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
        origin: options?.origin,
        automation: options?.automation,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.copyAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automationId: '$[0]',
                origin: '$[1].origin',
                automation: '$[1].automation',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['automationId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Creates a draft automation.
 * @public
 * @documentationMaturity preview
 * @permissionId AUTOMATIONS.AUTOMATION_DRAFT_CREATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.CreateDraftAutomation
 */
export async function createDraftAutomation(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: options?.automation,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.createDraftAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automation: '$[0].automation',
                fields: '$[0].fields',
            },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Gets the draft of the given original automation if exists, or creates one and returns it
 *
 * - if the original automation is a draft, returns the original automation
 * @param originalAutomationId - Original automation id
 * @public
 * @documentationMaturity preview
 * @requiredField originalAutomationId
 * @permissionId AUTOMATIONS.AUTOMATION_DRAFT_CREATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.GetOrCreateDraftAutomation
 */
export async function getOrCreateDraftAutomation(originalAutomationId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        originalAutomationId: originalAutomationId,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.getOrCreateDraftAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                originalAutomationId: '$[0]',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['originalAutomationId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Updates a draft automation
 * @param _id - Automation ID.
 * @public
 * @documentationMaturity preview
 * @requiredField _id
 * @requiredField automation
 * @permissionId AUTOMATIONS.AUTOMATION_DRAFT_UPDATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.UpdateDraftAutomation
 */
export async function updateDraftAutomation(_id, automation, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[3];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: { ...automation, id: _id },
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.updateDraftAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: { automation: '$[1]' },
            explicitPathsToArguments: {
                'automation.id': '$[0]',
                fields: '$[2].fields',
            },
            singleArgumentUnchanged: false,
        }, ['_id', 'automation', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Retrieves a list of automations including drafts. Max query filter depth is 3.
 *
 * Relevant automations for the query are returned. This includes automations created on the site and pre-installed automations.
 * If there's an existing override for a pre-installed automation, the override is returned in the query result.
 * The query only returns automations from apps that are installed on the site.
 *
 * - new drafts that are not related to existing automations will be returned in the list
 * - the response will contain a map of originalAutomationId => relatedDrafts
 *
 * To learn about working with _Query_ endpoints, see
 * [API Query Language](https://dev.wix.com/api/rest/getting-started/api-query-language),
 * [Sorting and Paging](https://dev.wix.com/api/rest/getting-started/pagination),
 * and [Field Projection](https://dev.wix.com/api/rest/getting-started/field-projection).
 * @public
 * @documentationMaturity preview
 * @permissionId AUTOMATIONS.AUTOMATION_DRAFT_READ
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.QueryAutomationsWithDrafts
 */
export async function queryAutomationsWithDrafts(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        query: options?.query,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.queryAutomationsWithDrafts(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                query: '$[0].query',
                fields: '$[0].fields',
            },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Deletes a draft automation.
 * @param automationId - Id of the draft automation to delete.
 * @public
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_DRAFT_DELETE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.DeleteDraftAutomation
 */
export async function deleteDraftAutomation(automationId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.deleteDraftAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { automationId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['automationId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Publishes a draft automation, applying the changes to live automation
 * @param automationId - Id of the draft automation to publish.
 * @public
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_UPDATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.PublishDraftAutomation
 */
export async function publishDraftAutomation(automationId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.publishDraftAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automationId: '$[0]',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['automationId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Validates the automation without requiring the automation ID to be passed in.
 * @param automation - Automation to validate.
 * @public
 * @documentationMaturity preview
 * @requiredField automation
 * @permissionId AUTOMATIONS.AUTOMATION_VALIDATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.ValidateAutomation
 */
export async function validateAutomation(automation, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automation: automation,
        validationSettings: options?.validationSettings,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.validateAutomation(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automation: '$[0]',
                validationSettings: '$[1].validationSettings',
            },
            singleArgumentUnchanged: false,
        }, ['automation', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Validate Automation by automation ID
 * @param automationId - Automation ID
 * @public
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_VALIDATE
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.ValidateAutomationById
 */
export async function validateAutomationById(automationId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
        validationSettings: options?.validationSettings,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.validateAutomationById(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automationId: '$[0]',
                validationSettings: '$[1].validationSettings',
            },
            singleArgumentUnchanged: false,
        }, ['automationId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Gets the payload schema received by the action whose ID is passed in.
 * @public
 * @documentationMaturity preview
 * @requiredField identifiers
 * @requiredField identifiers.actionId
 * @requiredField identifiers.automationId
 * @permissionId AUTOMATIONS.AUTOMATION_READ
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.GetAutomationActionSchema
 */
export async function getAutomationActionSchema(identifiers) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: identifiers?.automationId,
        actionId: identifiers?.actionId,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.getAutomationActionSchema(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automationId: '$[0].automationId',
                actionId: '$[0].actionId',
            },
            singleArgumentUnchanged: false,
        }, ['identifiers']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Gets action quota information.
 * @public
 * @documentationMaturity preview
 * @permissionId AUTOMATIONS.AUTOMATION_READ
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationsService.GetActionsQuotaInfo
 */
export async function getActionsQuotaInfo() {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[0];
    const payload = renameKeysFromSDKRequestToRESTRequest({});
    const reqOpts = ambassadorWixAutomationsV2Automation.getActionsQuotaInfo(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {},
            singleArgumentUnchanged: false,
        }, []);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
/**
 * Get automation revision
 * @param automationId - Automation ID.
 * @internal
 * @documentationMaturity preview
 * @requiredField automationId
 * @permissionId AUTOMATIONS.AUTOMATION_REVISION_READ
 * @permissionScope Set Up Automations
 * @permissionScopeId SCOPE.CRM.SETUP-AUTOMATIONS
 * @applicableIdentity APP
 * @fqn wix.automations.v2.AutomationRevisionsService.GetAutomationRevision
 */
export async function getAutomationRevision(automationId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = renameKeysFromSDKRequestToRESTRequest({
        automationId: automationId,
        revision: options?.revision,
        fields: options?.fields,
    });
    const reqOpts = ambassadorWixAutomationsV2Automation.getAutomationRevision(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return renameKeysFromRESTResponseToSDKResponse(result.data);
    }
    catch (err) {
        const transformedError = sdkTransformError(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                automationId: '$[0]',
                revision: '$[1].revision',
                fields: '$[1].fields',
            },
            singleArgumentUnchanged: false,
        }, ['automationId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
//# sourceMappingURL=automations-v2-automation-automations-service-v-2.universal.js.map