import * as ambassadorWixAutomationsV2Automation from './automations-v2-automation-automations-service-v-2.http.js';
export function createAutomation() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.createAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function getAutomation() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.getAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'GET',
        path: '/v2/automations/{automationId}',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function updateAutomation() {
    const payload = { automation: { id: ':automationId' } };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.updateAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'PATCH',
        path: '/v2/automations/{automation.id}',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function deleteAutomation() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.deleteAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'DELETE',
        path: '/v2/automations/{automationId}',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function bulkDeleteAutomations() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.bulkDeleteAutomations(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/bulk/automations/delete',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function createPreinstalledAutomation() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.createPreinstalledAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/preinstalled-automation',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function updatePreinstalledAutomation() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.updatePreinstalledAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'PATCH',
        path: '/v2/preinstalled-automation',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function deletePreinstalledAutomation() {
    const payload = { componentId: ':componentId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.deletePreinstalledAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'DELETE',
        path: '/v2/preinstalled-automation/{componentId}',
        pathParams: { componentId: 'componentId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function queryPreinstalledAutomationsForApp() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.queryPreinstalledAutomationsForApp(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/preinstalled-automations/query',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function queryAutomations() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.queryAutomations(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/query',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function copyAutomation() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.copyAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/{automationId}/copy',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function createDraftAutomation() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.createDraftAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/drafts',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function getOrCreateDraftAutomation() {
    const payload = { originalAutomationId: ':originalAutomationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.getOrCreateDraftAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/drafts/get-or-create/original-automation-id/{originalAutomationId}',
        pathParams: { originalAutomationId: 'originalAutomationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function updateDraftAutomation() {
    const payload = { automation: { id: ':automationId' } };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.updateDraftAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'PATCH',
        path: '/v2/automations/drafts/{automation.id}',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function queryAutomationsWithDrafts() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.queryAutomationsWithDrafts(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/query-with-drafts',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function deleteDraftAutomation() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.deleteDraftAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'DELETE',
        path: '/v2/automations/drafts/{automationId}',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function publishDraftAutomation() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.publishDraftAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/drafts/{automationId}/publish',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function validateAutomation() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.validateAutomation(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/validate',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function validateAutomationById() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.validateAutomationById(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'POST',
        path: '/v2/automations/{automationId}/validate',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function getAutomationActionSchema() {
    const payload = {
        automationId: ':automationId',
        actionId: ':actionId',
    };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.getAutomationActionSchema(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'GET',
        path: '/v2/automations/schema/{automationId}/{actionId}',
        pathParams: { automationId: 'automationId', actionId: 'actionId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function getActionsQuotaInfo() {
    const payload = {};
    const getRequestOptions = ambassadorWixAutomationsV2Automation.getActionsQuotaInfo(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'GET',
        path: '/v2/automations/actions/quota',
        pathParams: {},
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
export function getAutomationRevision() {
    const payload = { automationId: ':automationId' };
    const getRequestOptions = ambassadorWixAutomationsV2Automation.getAutomationRevision(payload);
    const getUrl = (context) => {
        const { url } = getRequestOptions(context);
        return url;
    };
    return {
        getUrl,
        httpMethod: 'GET',
        path: '/v1/automation-revisions/{automationId}',
        pathParams: { automationId: 'automationId' },
        __requestType: null,
        __originalRequestType: null,
        __responseType: null,
        __originalResponseType: null,
    };
}
//# sourceMappingURL=automations-v2-automation-automations-service-v-2.meta.js.map